Index: /Dev/trunk/src/client/qed-client/model/classes/_Class.js
===================================================================
--- /Dev/trunk/src/client/qed-client/model/classes/_Class.js	(revision 524)
+++ /Dev/trunk/src/client/qed-client/model/classes/_Class.js	(revision 525)
@@ -71,7 +71,9 @@
             } else if ( lang.isObject(obj) ) {
                 objectFuns.forEach(obj,function(v,prop){
-                    if ( v === null ||
-                         v === "" ||
-                         (typeof v === "number" && isNaN(v)) ) {
+                    if ( ( v === null ||
+                           v === "" ||
+                           (typeof v === "number" && isNaN(v)) ) && 
+                         prop !== 'subcode' ) // HACK : this hardcoded exclusion for subcode is quite nasty
+                    {
                         delete obj[prop];
                     } else {
Index: /Dev/trunk/src/client/qed-client/model/widgets/QuestionEditorPreviewItem.js
===================================================================
--- /Dev/trunk/src/client/qed-client/model/widgets/QuestionEditorPreviewItem.js	(revision 524)
+++ /Dev/trunk/src/client/qed-client/model/widgets/QuestionEditorPreviewItem.js	(revision 525)
@@ -149,6 +149,8 @@
             if ( this.innerWidget !== null ) {
                 if ( this._editing === true ) {
-                    this._onChange();
-                    // how to force event on widget here?
+                    // because the widget doesn't generate an event
+                    // unless it loses focus, we set the value here
+                    // just to be sure not to lose any user input
+                    this._setValueInternal(this.innerWidget.get('value'));
                 }
                 this.removeChild(this.innerWidget);
Index: /Dev/trunk/src/client/qed-client/model/widgets/questions/ScaleInputWidget.js
===================================================================
--- /Dev/trunk/src/client/qed-client/model/widgets/questions/ScaleInputWidget.js	(revision 524)
+++ /Dev/trunk/src/client/qed-client/model/widgets/questions/ScaleInputWidget.js	(revision 525)
@@ -22,5 +22,5 @@
             this.minNode.innerHTML = this.minLabel || "";
             this.maxNode.innerHTML = this.maxLabel || "";
-            if ( this.naLabel !== null ) {
+            if ( this.naLabel ) {
                 this.naNode.innerHTML = this.naLabel;
             }
@@ -56,5 +56,5 @@
                     className: 'max'
                 }, tr);
-                if ( this.naLabel !== null && this.naLabel !== "" ) {
+                if ( this.naLabel ) {
                     td = domConstruct.create("td", {}, tr);
                     radio = new RadioButton({
Index: /Dev/trunk/src/client/qed-client/widgets/ListWidget.js
===================================================================
--- /Dev/trunk/src/client/qed-client/widgets/ListWidget.js	(revision 524)
+++ /Dev/trunk/src/client/qed-client/widgets/ListWidget.js	(revision 525)
@@ -98,7 +98,13 @@
         _getValueAttr: function() {
             return array.map(
-                this._getDescendantFormWidgets(),
-                function(child) { return child.get('value'); }
-                ,this);
+                this.source.getAllNodes(),
+                lang.hitch(this,function(node){
+                    var widget = registry.byNode(node);
+                    if ( widget && 'value' in widget ) {
+                        return widget.get('value');
+                    } else {
+                        return this.source.getItem(node.id).data;
+                    }
+                }));
         },
         _setValueAttr: function(value,priorityChange) {
Index: /Dev/trunk/src/client/qed-client/widgets/_ComplexValueMixin.js
===================================================================
--- /Dev/trunk/src/client/qed-client/widgets/_ComplexValueMixin.js	(revision 524)
+++ /Dev/trunk/src/client/qed-client/widgets/_ComplexValueMixin.js	(revision 525)
@@ -64,5 +64,7 @@
                     if (typeof widgets[0].checked === 'boolean') {
                         array.forEach(widgets, function(w){
-                            w.set('value', array.indexOf(values, w._get('value')) !== -1, priorityChange);
+                            w.set('value',
+                                  array.indexOf(values,w._get('value'))!==-1,
+                                  priorityChange);
                         });
                     } else if (widgets[0].multiple) {
@@ -90,4 +92,5 @@
         _setDisabledAttr: function(disabled) {
             this.inherited(arguments);
+            this._set('disabled',disabled);
             array.forEach(
                 this._getDescendantFormWidgets(),
@@ -98,4 +101,5 @@
         _setReadOnlyAttr: function(readOnly) {
             this.inherited(arguments);
+            this._set('readOnly',readOnly);
             array.forEach(
                 this._getDescendantFormWidgets(),
Index: /Dev/trunk/src/server/api/categories.js
===================================================================
--- /Dev/trunk/src/server/api/categories.js	(revision 525)
+++ /Dev/trunk/src/server/api/categories.js	(revision 525)
@@ -0,0 +1,42 @@
+var express = require("express")
+  , HTTPResult = require("../util/http-result")
+  , _ = require("underscore")
+  ;
+
+module.exports = function(couch,schema) {
+    var util = require('./util')(couch,schema);
+    var topics = require('./topics')(couch,schema);
+    var exports = {};
+
+    var app = exports.app = express();
+
+    var getCategories = exports.getCategories = function(sub) {
+        var url = '_design/questions/_view/'+(sub||'all');
+        return couch.get(url,{query:{reduce:true,group:true,group_level:1}})
+        .handle({
+            200: function(result) {
+                return _.map(result.rows, function(item) {
+                    return { name:item.key[0], count:item.value };
+                });
+            },
+            default: util.handleUnknownResponse
+        });
+    };
+
+    app.get('/',
+        util.ensureMIME(util.JSON_MIME),
+        function(req,res) {
+            var sub = 'published' in req.query && 'published';
+            getCategories(sub)
+            .handle(res.send.bind(res));
+        });
+    app.get('/:category/topics',
+        util.ensureMIME(util.JSON_MIME),
+        function(req,res) {
+            var category = req.params.category;
+            var sub = 'published' in req.query && 'published';
+            topics.getTopicsWithCategory(category,sub)
+            .handle(res.send.bind(res));
+        });
+    return exports;
+};
Index: /Dev/trunk/src/server/api/open.js
===================================================================
--- /Dev/trunk/src/server/api/open.js	(revision 525)
+++ /Dev/trunk/src/server/api/open.js	(revision 525)
@@ -0,0 +1,147 @@
+var express = require("express")
+  , cryptoken = require("../util/crypto-token")
+  , HTTPResult = require("../util/http-result")
+  , etags = require("../util/etags")
+  ;
+
+module.exports = function(couch,schema) {
+    var exports = {};
+
+    var util = require('./util')(couch,schema);
+    var app = exports.app = express();
+
+    var isSurveyRunRunning = exports.isSurveyRunRunning = function(surveyRun) {
+        var now = new Date();
+        var afterStart = !surveyRun.startDate || now >= new Date(surveyRun.startDate);
+        var beforeEnd = !surveyRun.endDate || now <= new Date(surveyRun.endDate);
+        return afterStart && beforeEnd;
+    };
+
+    app.get('/responses/:id',
+        util.ensureMIME(util.JSON_MIME),
+        function(req,res) {
+            var id = req.params.id;
+            var rev = etags.parse(req.header('If-Non-Match'))[0];
+            var secret = req.query.secret;
+            util.getDocument(id,rev,'Response')
+            .handle({
+                200: function(response) {
+                    if ( response.secret === secret ) {
+                        return util.getDocument(response.surveyRunId,[],'SurveyRun')
+                        .handle({
+                            200: function(surveyRun) {
+                                if ( !isSurveyRunRunning(surveyRun) ) {
+                                    return new HTTPResult(404,{error:"Survey is not running anymore."});
+                                } else {
+                                    response._surveyRun = surveyRun;
+                                    return response;
+                                }
+                            }
+                        });
+                    } else {
+                        return new HTTPResult(403,{error: "Wrong secret for response"});
+                    }
+                }
+            })
+            .handle(res.send.bind(res));
+        });
+    app.post('/responses',
+        util.ensureMIME(util.JSON_MIME),
+        function(req,res) {
+            var secret = req.query.secret;
+            var response = req.body;
+            delete response._surveyRun;
+            util.getDocument(response.surveyRunId,[],'SurveyRun')
+            .handle({
+                200: function(surveyRun) {
+                    if ( surveyRun.secret !== secret ) {
+                        return new HTTPResult(403,{error:"Wrong secret for surveyRun."});
+                    } else if ( !isSurveyRunRunning(surveyRun) ) {
+                        return new HTTPResult(404,{error:"Survey is not running anymore."});
+                    } else if ( surveyRun.mode === 'closed' ) {
+                        return new HTTPResult(403,{error:"Survey is closed and doesn't allow new responses."});
+                    } else {
+                        return cryptoken()
+                        .then(function(token) {
+                            response.secret = token;
+                            return util.postDocument('Response',response)
+                            .then(function(doc){
+                                doc._surveyRun = surveyRun;
+                                return doc;
+                            });
+                        });
+                    }
+                }
+            })
+            .handle(res.send.bind(res));
+        });
+    app.put('/responses/:id',
+        util.ensureMIME(util.JSON_MIME),
+        function(req,res){
+            var id = req.params.id;
+            var doc = req.body;
+            var rev = etags.parse(req.header('If-Match'))[0] || (doc && doc._rev);
+            var secret = req.query.secret || doc.secret;
+            delete doc._surveyRun;
+            util.getDocument(id,[],'Response')
+            .handle({
+                200: function(prev) {
+                    if ( prev.secret !== secret ) {
+                        return new HTTPResult(403,{error: "Secrets are not the same."});
+                    } else if ( prev.surveyRunId !== doc.surveyRunId ) {
+                        return new HTTPResult(400,{error:"Response cannot change it's surveyRunId."});
+                    } else {
+                        doc.secret = secret; // restore in case it got lost or was changed
+                        return util.getDocument(doc.surveyRunId,[],'SurveyRun')
+                        .handle({
+                            200: function(surveyRun) {
+                                if ( !isSurveyRunRunning(surveyRun) ) {
+                                    return new HTTPResult(404,{error:"Survey is not running anymore."});
+                                } else {
+                                    return util.putDocument(id,rev,'Response',doc)
+                                    .handle({
+                                        200: function(doc) {
+                                            doc._surveyRun = surveyRun;
+                                            return new HTTPResult(201,doc);
+                                        }
+                                    });
+                                }
+                            }
+                        });
+                    }
+                }
+            })
+            .handle(res.send.bind(res));
+        });
+    app.delete('/responses/:id',
+        util.ensureMIME(util.JSON_MIME),
+        function(req,res){
+            var id = req.params.id;
+            var doc = req.body;
+            var rev = etags.parse(req.header('If-Match'))[0] || (doc && doc._rev);
+            var secret = req.query.secret || doc.secret;
+            delete doc._surveyRun;
+            util.getDocument(id,[],'Response')
+            .handle({
+                200: function(prev) {
+                    if ( prev.secret !== secret ) {
+                        return new HTTPResult(403,{error: "Secrets are not the same."});
+                    } else {
+                        return util.getDocument(doc.surveyRunId,[],'SurveyRun')
+                        .handle({
+                            200: function(surveyRun) {
+                                if ( surveyRun.respondentCanDeleteOwnResponse === true ) {
+                                    return util.deleteDocument(id,rev,doc);
+                                } else {
+                                    return new HTTPResult(403,{error:"Not allowed to delete response."});
+                                }
+                            }
+                        });
+                    }
+                }
+            })
+            .handle(res.send.bind(res));
+        });
+
+    return exports;
+};
Index: /Dev/trunk/src/server/api/questions.js
===================================================================
--- /Dev/trunk/src/server/api/questions.js	(revision 525)
+++ /Dev/trunk/src/server/api/questions.js	(revision 525)
@@ -0,0 +1,169 @@
+var express = require("express")
+  , HTTPResult = require("../util/http-result")
+  , _ = require("underscore")
+  , objF = require("../util/object")
+  , etags = require("../util/etags")
+  ;
+
+module.exports = function(couch,schema) {
+    var util = require('./util')(couch,schema);
+    var exports = {};
+
+    var app = exports.app = express();
+
+    var getQuestionsWithCode = exports.getQuestionsWithCode = function(code,sub) {
+        var url = '_design/questions/_view/'+(sub||'all')+'_by_code';
+        var query = {reduce:false,include_docs:true,key:code};
+        return couch.get(url,{query:query})
+        .handle({
+            200: util.handleRowDocs,
+            default: util.handleUnknownResponse
+        });
+    };
+    var getQuestions = exports.getQuestions = function(sub) {
+        var url = '_design/questions/_view/'+(sub||'all');
+        var query = {reduce:false,include_docs:true};
+        return couch.get(url,{query:query})
+        .handle({
+            200: util.handleRowDocs,
+            default: util.handleUnknownResponse
+        });
+    };
+    var getQuestionsAndCodes = exports.getQuestionsAndCodes = function(sub) {
+        var url = '_design/questions/_view/'+(sub||'all')+'_by_code';
+        var query = {};
+        return couch.get(url,{query:query})
+        .handle({
+            200: util.handleRowDictOfValues,
+            default: util.handleUnknownResponse
+        });
+    };
+    var getQuestionsWithTopic = exports.getQuestionsWithTopic = function(topic,sub) {
+        var url = '_design/questions/_view/'+(sub||'all')+'_topics';
+        var query = {reduce:false,include_docs:true,key:topic};
+        return couch.get(url,{query:query})
+        .handle({
+            200: util.handleRowDocs,
+            default: util.handleUnknownResponse
+        });
+    };
+    var getQuestionsWithCategoryAndTopic = exports.getQuestionsWithCategoryAndTopic = function(category,topic,sub) {
+        var hasTopic = typeof topic !== 'undefined';
+        var url = '_design/questions/_view/'+(sub||'all');
+        var query = {reduce:false,include_docs:true,
+                     startkey:hasTopic?[category,topic]:[category],
+                     endkey:hasTopic?[category,topic]:[category,{}]};
+        return couch.get(url,{query:query})
+        .handle({
+            200: util.handleRowDocs,
+            default: util.handleUnknownResponse
+        });
+    };
+    var areElementsUnique = exports.areElementsUnique = function(array) {
+        return _.uniq(array).length === array.length;
+    };
+    var getVariablesAndIds = exports.getVariablesAndIds = function(sub) {
+        var url = '_design/questions/_view/'+(sub||'all')+'_variables';
+        return couch.get(url)
+        .handle({
+            200: util.handleRowDictOfValues,
+            default: util.handleUnknownResponse
+        });
+    };
+    var collectVariables = exports.collectVariables = function(question) {
+        return _.chain(objF.collectFields('subcode',question.content))
+        .map(function(subcode){
+            return question.code+subcode;
+        }).value();
+    };
+
+    app.get('/',
+        util.ensureMIME(util.JSON_MIME),
+        function(req,res) {
+            var sub = 'published' in req.query && 'published';
+            var hr;
+            if ( 'category' in req.query ) {
+                hr = getQuestionsWithCategoryAndTopic(req.query.category,
+                                                      req.query.topic,sub);
+            } else if ( 'topic' in req.query ) {
+                hr = getQuestionsWithTopic(req.query.topic,sub);
+            } else if ( 'code' in req.query ) {
+                hr = getQuestionsWithCode(req.query.code,sub);
+            } else {
+                hr = getQuestions(sub);
+            }
+            hr.handle(res.send.bind(res));
+        });
+    app.post('/',
+        util.ensureMIME(util.JSON_MIME),
+        function (req,res) {
+            var doc = req.body;
+            var ourVars = collectVariables(doc);
+            var hr;
+            var dups = objF.findDuplicates(ourVars);
+            if ( dups.length > 0 ) {
+                hr = new HTTPResult(400,{error:"Question defines variable(s) "+
+                                               dups.join(',')+
+                                               " multiple times (subcodes not unique)."});
+            } else {
+                hr = getVariablesAndIds()
+                .handle({
+                    200: function(vars) {
+                        vars = _.chain(vars).keys().uniq().value(); // don't punish us for others mistakes
+                        dups = objF.findDuplicates(vars.concat(ourVars));
+                        if ( dups.length > 0 ) {
+                            return new HTTPResult(400,{error:"Question redefines variable(s) "+
+                                                             dups.join(',')+
+                                                             " (already defined in other question(s))."});
+                        } else {
+                            return util.postDocument('Question',doc);
+                        }
+                    }
+                });
+            }
+            hr.handle(res.send.bind(res));
+        });
+    app.get('/:id',
+        util.ensureMIME(util.JSON_MIME),
+        util.makeDocGet_id('Question'));
+    app.put('/:id',
+        util.ensureMIME(util.JSON_MIME),
+        function (req,res) {
+            var id = req.params.id;
+            var doc = req.body;
+            var rev = etags.parse(req.header('If-Match'))[0] || (doc && doc._rev);
+            var ourVars = collectVariables(doc);
+            var hr;
+            var dups = objF.findDuplicates(ourVars);
+            if ( dups.length > 0 ) {
+                hr = new HTTPResult(400,{error:"Question defines variable(s) "+
+                                               dups.join(',')+
+                                               " multiple times (subcodes not unique)."});
+            } else {
+                hr = getVariablesAndIds()
+                .handle({
+                    200: function(vars) {
+                        vars = _.chain(vars).map(function(otherId,otherVar){
+                            return otherId !== id ? otherVar : null;
+                        }).filter(function(otherCode){
+                            return otherCode !== null;
+                        }).uniq().value(); // don't punish us for others mistakes
+                        dups = objF.findDuplicates(vars.concat(ourVars));
+                        if ( dups.length > 0 ) {
+                            return new HTTPResult(400,{error:"Question redefines variable(s) "+
+                                                             dups.join(',')+
+                                                             " (already defined in other question(s))."});
+                        } else {
+                            return util.putDocument(id,rev,'Question',doc);
+                        }
+                    }
+                });
+            }
+            hr.handle(res.send.bind(res));
+        });
+    app.delete('/:id',
+        util.ensureMIME(util.JSON_MIME),
+        util.makeDocDel_id('Question'));
+
+    return exports;
+};
Index: /Dev/trunk/src/server/api/responses.js
===================================================================
--- /Dev/trunk/src/server/api/responses.js	(revision 525)
+++ /Dev/trunk/src/server/api/responses.js	(revision 525)
@@ -0,0 +1,72 @@
+var express = require("express")
+  , HTTPResult = require("../util/http-result")
+  , etags = require("../util/etags")
+  , cryptoken = require("../util/crypto-token")
+  , _ = require('underscore')
+  ;
+
+module.exports = function(couch,schema) {
+    var exports = {};
+
+    var util = require('./util')(couch,schema);
+    var app = exports.app = express();
+
+    var getResponsesBySurveyRunId = exports.getResponsesBySurveyRunId = function(surveyRunId) {
+        var url = '_design/responses/_view/by_surveyrun?key='+JSON.stringify(surveyRunId);
+        return couch.get(url)
+        .handle({
+            200: util.handleRowValues,
+            default: util.handleUnknownResponse
+        });
+    };
+
+    app.get('/',
+        util.ensureMIME(util.JSON_MIME),
+        function(req,res){
+            var hr;
+            if ( 'surveyRunId' in req.query ) {
+                hr = getResponsesBySurveyRunId(req.query.surveyRunId);
+            } else {
+                hr = util.getDocumentsOfType('Response');
+            }
+            hr.handle(res.send.bind(res));
+        });
+    app.get('/:id',
+        util.ensureMIME(util.JSON_MIME),
+        util.makeDocGet_id('Response'));
+    app.post('/api/responses',
+        util.ensureMIME(util.JSON_MIME),
+        function (req,res) {
+            var doc = req.body;
+            cryptoken()
+            .then(function(token) {
+                doc.secret = token;
+                return util.postDocument('Response',doc);
+            })
+            .handle(res.send.bind(res));
+        });
+    app.put('/:id',
+        util.ensureMIME(util.JSON_MIME),
+        function (req,res) {
+            var id = req.params.id;
+            var doc = req.body;
+            var rev = etags.parse(req.header('If-Match'))[0] || (doc && doc._rev);
+            var hr;
+            if ( typeof doc.secret === 'undefined' ) {
+                hr = util.randomToken()
+                .handle({
+                    201: function(token) {
+                        doc.secret = token;
+                        return util.putDocument(id,rev,'Response',doc);
+                    }
+                });
+            } else {
+                hr = util.putDocument(id,rev,'Response',doc);
+            }
+            hr.handle(res.send.bind(res));
+        });
+    app.delete('/:id',
+        util.ensureMIME(util.JSON_MIME),
+        util.makeDocDel_id('Response'));
+    return exports;
+};
Index: /Dev/trunk/src/server/api/surveyRuns.js
===================================================================
--- /Dev/trunk/src/server/api/surveyRuns.js	(revision 525)
+++ /Dev/trunk/src/server/api/surveyRuns.js	(revision 525)
@@ -0,0 +1,102 @@
+var express = require("express")
+  , HTTPResult = require("../util/http-result")
+  , cryptoken = require("../util/crypto-token")
+  , etags = require("../util/etags")
+  , _ = require('underscore')
+  ;
+
+module.exports = function(couch,schema) {
+    var exports = {};
+
+    var util = require('./util')(couch,schema);
+    var responses = require('./responses')(couch,schema);
+    var app = exports.app = express();
+
+    app.get('/',
+        util.ensureMIME(util.JSON_MIME),
+        util.makeDocsGet('SurveyRun'));
+    app.post('/',
+        util.ensureMIME(util.JSON_MIME),
+        function(req,res) {
+            var doc = req.body;
+            var hr;
+            if ( !util.isDocPublished(doc.survey) ) {
+                hr = new HTTPResult(400,{error:"Cannot run unpublished survey."});
+            } else {
+                hr = cryptoken()
+                .then(function(token) {
+                    doc.secret = token;
+                    return util.postDocument('SurveyRun',doc);
+                });
+            }
+            hr.handle(res.send.bind(res));
+        });
+    app.get('/:id',
+        util.ensureMIME(util.JSON_MIME),
+        util.makeDocGet_id('SurveyRun'));
+    app.put('/:id',
+        util.ensureMIME(util.JSON_MIME),
+        function (req,res) {
+            var id = req.params.id;
+            var doc = req.body;
+            var rev = etags.parse(req.header('If-Match'))[0] || (doc && doc._rev);
+            var hr;
+            if ( !util.isDocPublished(doc.survey) ) {
+                hr = new HTTPResult(400,{error:"Cannot run unpublished survey."});
+            } else if ( typeof doc.secret === 'undefined' ) {
+                hr = cryptoken()
+                .then(function(token) {
+                    doc.secret = token;
+                    return util.putDocument(id,rev,'SurveyRun',doc);
+                });
+            } else {
+                hr = util.putDocument(id,rev,'SurveyRun',doc);
+            }
+            hr.handle(res.send.bind(res));
+        });
+    app.delete('/:id',
+        util.ensureMIME(util.JSON_MIME),
+        function(req,res) {
+            var id = req.params.id;
+            var doc = req.body;
+            var rev = etags.parse(req.header('If-Match'))[0] || (doc && doc._rev);
+            responses.getResponsesBySurveyRunId(id)
+            .handle({
+                200: function(responses) {
+                    if ( responses.length > 0 ) {
+                        return new HTTPResult(403,{error:"Cannot delete run that has responses."});
+                    } else {
+                        return util.deleteDocument(id,rev);
+                    }
+                }
+            }).handle(res.send.bind(res));
+        });
+    app.get('/:id/responses',
+        util.ensureMIME(util.JSON_MIME),
+        function(req,res) {
+            var id = req.params.id;
+            responses.getResponsesBySurveyRunId(id)
+            .handle(res.send.bind(res));
+        });
+    app.get('/:id/responses.csv',
+        util.ensureMIME(util.CSV_MIME),
+        function(req, res) {
+            var id = req.params.id;
+            responses.getResponsesBySurveyRunId(id)
+            .handle({
+                200: function(responses) {
+                    var answers = _.map(responses,function(response){
+                        return response.answers;
+                    });
+                    res.set({
+                        'Content-Disposition': 'attachment; filename=surveyRun-'+id+'-responses.csv'
+                    });
+                    res.status(200);
+                    util.writeObjectsToCSVStream(answers, res);
+                    res.end();
+                },
+                default: res.send.bind(res)
+            });
+        });
+    return exports;
+};
Index: /Dev/trunk/src/server/api/surveys.js
===================================================================
--- /Dev/trunk/src/server/api/surveys.js	(revision 525)
+++ /Dev/trunk/src/server/api/surveys.js	(revision 525)
@@ -0,0 +1,81 @@
+var express = require("express")
+  , _ = require("underscore")
+  , HTTPResult = require("../util/http-result")
+  , etags = require("../util/etags")
+  ;
+
+module.exports = function(couch,schema) {
+    var exports = {};
+    var util = require('./util')(couch,schema);
+    var app = exports.app = express();
+
+    app.get('/',
+        util.ensureMIME(util.JSON_MIME),
+        function(req,res) {
+            var url;
+            if ( 'drafts' in req.query ) {
+                url = '_design/surveys/_view/drafts';
+            } else if ( 'published' in req.query ) {
+                url = '_design/surveys/_view/published';
+            } else {
+                url = '_design/default/_view/by_type?key='+JSON.stringify('Survey');
+            }
+            couch.get(url)
+            .handle({
+                200: function(result) {
+                    return _.map(result.rows, function(item) {
+                        return item.value;
+                    });
+                },
+                default: util.handleUnknownResponse
+            })
+            .handle(res.send.bind(res));
+        });
+    app.post('/',
+        util.ensureMIME(util.JSON_MIME),
+        function(req,res) {
+            var doc = req.body;
+            var hr;
+            if ( !util.areDocsUnique(doc.questions) ) {
+                hr = new HTTPResult(400,{error:"Survey contains duplicate questions."});
+            } else if ( util.isDocPublished(doc) &&
+                        !util.areDocsPublished(doc.questions) ) {
+                hr = new HTTPResult(400,{error:"Cannot publish Survey with unpublished questions."});
+            } else {
+                hr = util.postDocument('Survey',doc);
+            }
+            hr.handle(res.send.bind(res));
+        });
+    app.get('/:id',
+        util.ensureMIME(util.JSON_MIME),
+        util.makeDocGet_id('Survey'));
+    app.put('/:id',
+        util.ensureMIME(util.JSON_MIME),
+        function(req,res) {
+            var id = req.params.id;
+            var doc = req.body;
+            var rev = etags.parse(req.header('If-Match'))[0] || (doc && doc._rev);
+            if ( !util.areDocsUnique(doc.questions) ) {
+                new HTTPResult(400,{error:"Survey contains duplicate questions."})
+                .handle(res.send.bind(res));
+            } else if ( util.isDocPublished(doc) &&
+                        !util.areDocsPublished(doc.questions) ) {
+                new HTTPResult(400,{error:"Cannot publish Survey with unpublished questions."})
+                .handle(res.send.bind(res));
+            } else {
+                util.putDocument(id,rev,'Survey',doc)
+                .handle({
+                    201: function(doc) {
+                        res.set({
+                            'ETag': etags.format([doc._rev])
+                        }).send(201, doc);
+                    },
+                    default: res.send.bind(res)
+                });
+            }
+        });
+    app.delete('/:id',
+        util.ensureMIME(util.JSON_MIME),
+        util.makeDocDel_id('Survey'));
+    return exports;
+};
